 

local QuizHelper = CreateFrame ("frame", "QuizHelper", UIParent)
QuizHelper:RegisterEvent ("GOSSIP_SHOW")

QuizHelper:SetScript ("OnEvent", function (self, event)
	if (event == "GOSSIP_SHOW") then
		if (select (6, strsplit ("-", UnitGUID ("target") or "")) == "110035" or select (6, strsplit ("-", UnitGUID ("target") or "")) == "110034") then
			QuizHelper.Run()
		end
	end
end)

function QuizHelper.Trim (s)
	local from = s:match"^%s*()"
	return from > #s and "" or s:match(".*%S", from)
end

function QuizHelper.Initialize()
	QuizHelper.Initialized = true
	local answers = {strsplit (",", LibStub ("AceLocale-3.0"):GetLocale ("QuizHelper")["S_CORRECT_ANSWERS"])}
	QuizHelper.Answers = {}
	for index, answer in ipairs (answers) do
		QuizHelper.Answers [QuizHelper.Trim (answer):lower()] = true
	end
	
	local CorrectAnswer = CreateFrame ("frame", "QuizHelperCorrectAnswerFrame", GossipTitleButton7)
	CorrectAnswer:SetSize (180, 20)
	CorrectAnswer:SetPoint ("topleft", GossipTitleButton7, "bottomleft", 0, -80)
	local answer = CorrectAnswer:CreateFontString (nil, "artwork", "GameFontNormal")
	answer:SetPoint ("center")
	if (GetLocale() ~= "enUS") then
		local localizedWarning = CorrectAnswer:CreateFontString (nil, "artwork", "GameFontNormal")
		localizedWarning:SetPoint ("topleft", CorrectAnswer, "bottomleft", 2, -2)
		localizedWarning:SetText ("your client isn't in english, this addon isn't localized for all languages yet.")
		localizedWarning:SetSize (300, 40)
		localizedWarning:SetJustifyH ("left")
	end
	local spoiler = CorrectAnswer:CreateTexture (nil, "overlay")
	spoiler:SetAllPoints()
	spoiler:SetColorTexture (0, 0, 0, 1)
	CorrectAnswer:SetScript ("OnEnter", function()
		spoiler:SetAlpha (.2)
	end)
	CorrectAnswer:SetScript ("OnLeave", function()
		spoiler:SetAlpha (1)
	end)
	CorrectAnswer:SetScript ("OnShow", function()
		spoiler:SetAlpha (1)
	end)
	QuizHelper.AnswerString = answer
end

function QuizHelper.Run()
	if (not QuizHelper.Initialized) then
		QuizHelper.Initialize()
	end
	local TheAnswerIs
	local A1 = select (1, GetGossipOptions())
	local A2 = select (3, GetGossipOptions())
	local A3 = select (5, GetGossipOptions())
	local A4 = select (7, GetGossipOptions())
	local options = {A1, A2, A3, A4}
	
	for i = 1, #options do
		local formatedOption = string.lower (options [i])
		formatedOption = QuizHelper.Trim (formatedOption)
		if (formatedOption:find ("%.", -1)) then
			formatedOption = formatedOption:sub (1, -2)
		end
		formatedOption = formatedOption:gsub ("\"", "")
		
		if (QuizHelper.Answers [formatedOption]) then
			TheAnswerIs = options [i]
			break
		end
	end
	
	QuizHelper.AnswerString:SetText (TheAnswerIs or "--x--x--")
	--print ("The Answer Is:", TheAnswerIs)
end

